
#include "config.h"


#ifdef HAVE_MEMSET
#define grzero(src,sz) memset(src,0,sz)
#elif HAVE_BZERO
#define grzero(src,sz) bzero(src,sz)
#else 
#error "FATAL: bzero and memset both absent\n"
#endif

#ifdef HAVE_MEMCHR
#define grchr(src,var,sz) memchr(src,(var),sz)
#elif HAVE_STRCHR
#define grchr(src,var,sz) strchr(src,(var))
#elif HAVE_INDEX
#define grchr(src,var,sz) index(src,(var))
#else 
#error "FATAL: bzero, strchr, and index all absent\n"
#endif

#ifdef HAVE_MEMCPY
#define grcpy(dest, src, sz) memcpy(dest,src,sz)
#elif HAVE_BCOPY
#define grcpy(dest, src, sz) bcopy(src, dest, sz)
#endif


#ifdef STDC_HEADERS
#include <stdio.h>
#else
#ifdef HAVE_MALLOC_H
#include <malloc.h>
#endif
#endif

#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif

#include <ctype.h>

#ifdef HAVE_ERRNO_H
#include <errno.h>
#endif

#ifdef HAVE_NETDB_H
#include <netdb.h>
#endif

#ifdef HAVE_NETINET_IN_H
#include <netinet/in.h>
#endif

#ifdef HAVE_STRING_H
#include <string.h>
#endif

#ifdef HAVE_SYS_SOCKET_H
#include <sys/socket.h>
#endif

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#include <stdarg.h>
#include <dirent.h>
