/* (c) 2001 Brad Spengler   */

#include "includes.h"
#include "snorthead.h"

unsigned int count = 0;

extern int parseline(char *ibuf);
extern void sortstruct(int mode,int asc, unsigned int outnum);
extern char * namerate(int asc,int tasc, int numout, short big);
extern char * dstiprate(int asc, int tasc, int numout, short big);
extern char * srciprate(int asc, int tasc, int numout, short big);
extern char * catrate(int asc, int tasc, int numout, short big);

int main(void)
{

	FILE * snortlog;
	char buf[1024];
	char cgibuf[22],*p,*pend;
	/* subject to sort by */
	int a = 0;
	/* results to display */
	int b = 0;
	/* 0 = subject is descending 1 = subject is ascending */
	int c = 0;
	/* 0 = time is descending 1 = time is ascending */
	int d = 0;
	int x,sortmethod;
#ifndef SETVBUF_REVERSE
	setvbuf(stdout,NULL,_IONBF,0);
#else
	setvbuf(stdout,_IONBF,NULL,0);
#endif
	printf("Content-type: text/html\n\n");

	
	if((getenv("QUERY_STRING") == NULL) || !strlen(getenv("QUERY_STRING"))){
		a = ST_TIME;
		b = 20;
		c = 1;
		d = 1;
	} else {
		
	strncpy(cgibuf,getenv("QUERY_STRING"),sizeof(cgibuf));

	p=grchr(cgibuf,'=',strlen(cgibuf));
	if (p != NULL){
		*p = '\0';
		p++;
		pend=grchr(p,'&',strlen(p));
		if (pend != NULL){
			*pend = '\0';
			a = atoi(p);
			pend++;
			p=grchr(pend,'=',strlen(pend));
			if (p != NULL) {
				p++;
				pend = grchr(p,'&',strlen(p));
				if (pend != NULL) {
					*pend = '\0';
					b = atoi(p);
					pend++;
					p=grchr(pend,'=',strlen(pend));
					if (p != NULL) {
						p++;
						pend = grchr(p,'&',strlen(p));
						if (pend != NULL) {
							*pend = '\0';
							c = atoi(p);
							pend++;
							p=grchr(pend,'=',strlen(pend));
							if (p != NULL) {
								p++;
								d = atoi(p);
							}
						}
					}

				}
			}
		}
	}

	}

	if((a > 0) && (a <= ST_PRIORITY))
		sortmethod = a;
	else
		sortmethod = ST_TIME;

	if((snortlog=fopen(LOGFILE,"r")) == NULL) {
		printf("Unable to open snort log for reading.\n");
		return 1;
	}
		
	while(fgets(buf,sizeof(buf),snortlog)) {

		if(parseline(buf) == 1)
			grzero(&ids[count],sizeof(ids[count]));

	}
	if((b > count) || ((b != 10) && (b != 20) && (b != 50)))
		b = count;

	printf(
	"<HTML><HEAD><TITLE>grsecurity snortparse</TITLE>"
	"<meta http-equiv=\"refresh\" content=\""REFRESH";url=snortparse.cgi?"
	"a=%d&b=%d&c=%d&d=%d\"><STYLE TYPE=\"text/css\"><!--\n"
	"A:link {color:\"#000000\"; text-decoration: none; font-weight : 700}\n"
	"A:visited {color:\"#000000\"; text-decoration: none; font-weight : 700}\n"
	"A:hover {color:\"#000000\"; text-decoration: none; font-weight : 700}\n"
        "-->\n</STYLE></HEAD>"
	"<BODY><CENTER><b><font size=7>grsecurity snortparse</font></b>"
	"<br><br>"
	"<A HREF=\"snortparse.cgi?a=7&b=10&c=1&d=1\">"
	"[show last 10 attacks]</A>&nbsp;"
	"<A HREF=\"snortparse.cgi?a=7&b=50&c=1&d=1\">"
        "[show last 50 attacks]</A>&nbsp;"
	"<A HREF=\"snortparse.cgi?a=7&b=10&c=1&d=0\">"
	"[show earliest 10 attacks]</A>&nbsp;"
	"<A HREF=\"snortparse.cgi?a=7&b=50&c=1&d=0\">"
        "[show earliest 50 attacks]</A>&nbsp;"
        "<A HREF=\"snortparse.cgi?a=7&b=%d&c=1&d=1\">"
        "[show all attacks]</A>",a,b,c,d,count);

	printf("<br><br><table><td><font size=4>Least Recurring Attack: %s<br>"
	"Least Active Attacker: %s<br>Least Targeted Host: %s<br>"
	"Least Recurring Type of Attack: %s<br><br></font></td>",
	namerate(c,d,b,0),srciprate(c,d,b,0),dstiprate(c,d,b,0),
	catrate(c,d,b,0));

	printf("<td><font size=4>Most Recurring Attack: %s<br>"
	"Most Active Attacker: %s<br>Most Targeted Host: %s<br>"
	"Most Recurring Type of Attack: %s<br><br></font></td></table>"
	"<TABLE border=2 "
	"cellspacing=0 cellpadding=3 bordercolorlight=\"#333333\"" 
	"bordercolor=\"#FFFFFF\" bordercolordark=\"#000000\">\n<TR>",
	namerate(c,d,b,1),srciprate(c,d,b,1),
	dstiprate(c,d,b,1),catrate(c,d,b,1));

	printf("<TD bgcolor=\"5F7D9D\"><b>name</b><br>"
	"<font color=\"#000000\">[<A HREF=\"snortparse.cgi?a=1&b=%d&c=1&d=%d\">"
        "asc</A>/<A HREF=\"snortparse.cgi?a=1&b=%d&c=0&d=%d\">"
        "dec</A>]</TD>"

	"<TD bgcolor=\"5F7D9D\"><b>category</b><br>"
	"[<A HREF=\"snortparse.cgi?a=2&b=%d&c=1&d=%d\">"
        "asc</A>/<A HREF=\"snortparse.cgi?a=2&b=%d&c=0&d=%d\">"
        "dec</A>]"
	"</TD><TD bgcolor=\"5F7D9D\">"

	"<b>src ip</b><br>"
        "[<A HREF=\"snortparse.cgi?a=3&b=%d&c=1&d=%d\">"
        "asc</A>/<A HREF=\"snortparse.cgi?a=3&b=%d&c=0&d=%d\">"
        "dec</A>]"

	"</TD><TD bgcolor=\"5F7D9D\"><b>src port</b><br>"
        "[<A HREF=\"snortparse.cgi?a=5&b=%d&c=1&d=%d\">"
        "asc</A>/<A HREF=\"snortparse.cgi?a=5&b=%d&c=0&d=%d\">"
        "dec</A>]</TD>"

	"<TD bgcolor=\"5F7D9D\"><b>dest ip</b><br>"
        "[<A HREF=\"snortparse.cgi?a=4&b=%d&c=1&d=%d\">"
        "asc</A>/<A HREF=\"snortparse.cgi?a=4&b=%d&c=0&d=%d\">"
        "dec</A>]</TD>"

	"<TD bgcolor=\"5F7D9D\"><b>dest port</b><br>"
        "[<A HREF=\"snortparse.cgi?a=6&b=%d&c=1&d=%d\">"
        "asc</A>/<A HREF=\"snortparse.cgi?a=6&b=%d&c=0&d=%d\">"
        "dec</A>]</TD>"

	"<TD bgcolor=\"5F7D9D\"><b>time</b><br>"
        "[<A HREF=\"snortparse.cgi?a=7&b=%d&c=1&d=%d\">"
        "asc</A>/<A HREF=\"snortparse.cgi?a=7&b=%d&c=0&d=%d\">"
        "dec</A>]</TD>"

	"<TD bgcolor=\"5F7D9D\"><b>priority</b><br>"
        "[<A HREF=\"snortparse.cgi?a=9&b=%d&c=1&d=%d\">"
        "asc</A>/<A HREF=\"snortparse.cgi?a=9&b=%d&c=0&d=%d\">"
        "dec</A>]</TD>"

	"<TD bgcolor=\"5F7D9D\"><b>occurrence</b><br>"
        "[<A HREF=\"snortparse.cgi?a=8&b=%d&c=1&d=%d\">"
        "asc</A>/<A HREF=\"snortparse.cgi?a=8&b=%d&c=0&d=%d\">"
        "dec</A>]</TD>"

	"</TR>\n",
	b,d,b,d,b,d,b,d,b,d,b,d,b,d,b,d,
	b,d,b,d,b,d,b,d,b,d,b,d,b,d,b,d,b,d);	

	sortstruct(ST_TIME,d,count);
	sortstruct(sortmethod,c,b);

	for(x=0;x<b;x++)
			if(!ids[x].src_port && !ids[x].dst_port)
			printf(
	"<TR><TD>%s</TD>\n"
			       "<TD>%s</TD>"
	"<TD><A HREF=\"nslookup.cgi?h=%s\">%s</A></TD>\n"
			       "<TD>&nbsp;</TD>"
	"<TD><A HREF=\"nslookup.cgi?h=%s\">%s</A></TD>\n"
			       "<TD>&nbsp;</TD>"
			       "<TD>%s</TD><TD>%d</TD><TD>%ld</TD>"
			       "</TR>\n\n",
				ids[x].name,
				ids[x].cat,ids[x].src_ip,ids[x].src_ip,
				ids[x].dst_ip,ids[x].dst_ip,ids[x].time,
				ids[x].priority,ids[x].occurrence);
			else
			printf(
	"<TR><TD>%s</TD>\n"
			       "<TD>%s</TD>\n"
	"<TD><A HREF=\"nslookup.cgi?h=%s\">%s</A></TD>\n"
			       "<TD>%d</TD>\n"
	"<TD><A HREF=\"nslookup.cgi?h=%s\">%s</A></TD>\n"
			       "<TD>%d</TD>"
			       "<TD>%s</TD><TD>%d</TD><TD>%ld</TD></TR>\n\n",
				ids[x].name,ids[x].cat,
				ids[x].src_ip,ids[x].src_ip,ids[x].src_port,
				ids[x].dst_ip,ids[x].dst_ip,ids[x].dst_port,
				ids[x].time,ids[x].priority,ids[x].occurrence);
	printf("</FONT></TABLE></CENTER></BODY></HTML>");
	fclose(snortlog);
	return 0;
}
