/* (c) 2001 Brad Spengler  */

#include "includes.h"
#include "snorthead.h"

void swapstruct(void *src, void *dst)
{
	struct ids_info buf;

	grcpy(&buf,dst,sizeof(buf));
	grcpy(dst,src,sizeof(buf));
	grcpy(src,&buf,sizeof(buf));
}

static int newgap(int gap) {
	gap = gap * 10 / 13;
	if (gap < 1)
    		gap = 1;
	if (gap == 9 || gap == 10)
		gap = 11;
	return gap;
}



void sortstruct(int mode,int asc,unsigned int outnum)
{
	int gap = outnum;
	struct in_addr first,second;
	if (!asc){
	for (;;) {
		int swapped = 0;
    		int i;
 
   		gap = newgap(gap);
    		for (i = 0; i < outnum - gap; i++) {
		switch (mode) {
			case ST_NAME:
      			if (strcasecmp(ids[i].name,ids[i + gap].name) > 0) {
				swapstruct(&ids[i], &ids[i + gap]);
				swapped = 1;
      			} break;
			case ST_CAT:
      			if (strcmp(ids[i].cat,ids[i + gap].cat) > 0) {
				swapstruct(&ids[i], &ids[i + gap]);
				swapped = 1;
      			} break;
			case ST_SRCIP:
                        grzero(&first,sizeof(first));
                        grzero(&second,sizeof(second));			
			inet_aton(ids[i].src_ip,&first);
			inet_aton(ids[i + gap].src_ip,&second);
      			if (htonl(first.s_addr) > htonl(second.s_addr)) {
				swapstruct(&ids[i], &ids[i + gap]);
				swapped = 1;
      			} break;
			case ST_DSTIP:
			grzero(&first,sizeof(first));
			grzero(&second,sizeof(second));
			inet_aton(ids[i].dst_ip,&first);
			inet_aton(ids[i + gap].dst_ip,&second);
      			if (htonl(first.s_addr) > htonl(second.s_addr)) {
				swapstruct(&ids[i], &ids[i + gap]);
				swapped = 1;
      			} break;
			case ST_SRCPRT:
      			if (ids[i].src_port > ids[i + gap].src_port) {
				swapstruct(&ids[i], &ids[i + gap]);
				swapped = 1;
      			} break;
			case ST_DSTPRT:
      			if (ids[i].dst_port > ids[i + gap].dst_port) {
				swapstruct(&ids[i], &ids[i + gap]);
				swapped = 1;
      			} break;
			case ST_TIME:
      			if (strcmp(ids[i].time,ids[i + gap].time) > 0) {
				swapstruct(&ids[i], &ids[i + gap]);
				swapped = 1;
      			} break;
			case ST_OCCUR:
      			if (ids[i].occurrence > ids[i + gap].occurrence) {
				swapstruct(&ids[i], &ids[i + gap]);
				swapped = 1;
      			} break;
			case ST_PRIORITY:
      			if (ids[i].priority > ids[i + gap].priority) {
				swapstruct(&ids[i], &ids[i + gap]);
				swapped = 1;
      			} break;
			default: break;
    		}

    		}
		if (gap == 1 && !swapped)
      			break;
	}
	} else {
	for (;;) {
		int swapped = 0;
    		int i;
 
   		gap = newgap(gap);
    		for (i = 0; i < outnum - gap; i++) {
		switch (mode) {
			case ST_NAME:
      			if (strcasecmp(ids[i].name,ids[i + gap].name) < 0) {
				swapstruct(&ids[i], &ids[i + gap]);
				swapped = 1;
      			} break;
			case ST_CAT:
      			if (strcmp(ids[i].cat,ids[i + gap].cat) < 0) {
				swapstruct(&ids[i], &ids[i + gap]);
				swapped = 1;
      			} break;
			case ST_SRCIP:
                        grzero(&first,sizeof(first));
                        grzero(&second,sizeof(second));			
			inet_aton(ids[i].src_ip,&first);
			inet_aton(ids[i + gap].src_ip,&second);
      			if (htonl(first.s_addr) < htonl(second.s_addr)) {
				swapstruct(&ids[i], &ids[i + gap]);
				swapped = 1;
      			} break;
			case ST_DSTIP:
                        grzero(&first,sizeof(first));
                        grzero(&second,sizeof(second));			
			inet_aton(ids[i].dst_ip,&first);
			inet_aton(ids[i + gap].dst_ip,&second);
      			if (htonl(first.s_addr) < htonl(second.s_addr)) {
				swapstruct(&ids[i], &ids[i + gap]);
				swapped = 1;
      			} break;
			case ST_SRCPRT:
      			if (ids[i].src_port < ids[i + gap].src_port) {
				swapstruct(&ids[i], &ids[i + gap]);
				swapped = 1;
      			} break;
			case ST_DSTPRT:
      			if (ids[i].dst_port < ids[i + gap].dst_port) {
				swapstruct(&ids[i], &ids[i + gap]);
				swapped = 1;
      			} break;
			case ST_TIME:
      			if (strcmp(ids[i].time,ids[i + gap].time) < 0) {
				swapstruct(&ids[i], &ids[i + gap]);
				swapped = 1;
      			} break;
			case ST_OCCUR:
      			if (ids[i].occurrence < ids[i + gap].occurrence) {
				swapstruct(&ids[i], &ids[i + gap]);
				swapped = 1;
      			} break;
			case ST_PRIORITY:
      			if (ids[i].priority < ids[i + gap].priority) {
				swapstruct(&ids[i], &ids[i + gap]);
				swapped = 1;
      			} break;
			default: break;
    		}

    		}
		if (gap == 1 && !swapped)
      			break;
	}
	}

}
	
